#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Birrh info functionality.
#

import isds
import unittest

# Global envelope.
bi = isds.isds_birth_info()

class TestIsdsBirthInfo(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsBirthInfo, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.bi = isds.isds_birth_info()
        self.bi = None

    def test_biDate(self):
        self.bi = bi
        val = isds.isds_date(1992, 4, 20)
        self.assertEqual(self.bi.biDate, None, "Unexpected biDate value.")
        self.bi.biDate = val
        self.assertEqual(self.bi.biDate, val, "Unexpected biDate value.")
        self.bi.biDate = None
        self.assertEqual(self.bi.biDate, None, "Unexpected biDate value.")
        self.bi.biDate = val
        self.assertEqual(self.bi.biDate, val, "Unexpected biDate value.")

    def test_biCity(self):
        self.bi = bi
        val = "City"
        self.assertEqual(self.bi.biCity, None, "Unexpected biCity value.")
        self.bi.biCity = val
        self.assertEqual(self.bi.biCity, val, "Unexpected biCity value.")
        self.bi.biCity = None
        self.assertEqual(self.bi.biCity, None, "Unexpected biCity value.")
        self.bi.biCity = val
        self.assertEqual(self.bi.biCity, val, "Unexpected biCity value.")

    def test_biCounty(self):
        self.bi = bi
        val = "County"
        self.assertEqual(self.bi.biCounty, None, "Unexpected biCounty value.")
        self.bi.biCounty = val
        self.assertEqual(self.bi.biCounty, val, "Unexpected biCounty value.")
        self.bi.biCounty = None
        self.assertEqual(self.bi.biCounty, None, "Unexpected biCounty value.")
        self.bi.biCounty = val
        self.assertEqual(self.bi.biCounty, val, "Unexpected biCounty value.")

    def test_biState(self):
        self.bi = bi
        val = "State"
        self.assertEqual(self.bi.biState, None, "Unexpected biState value.")
        self.bi.biState = val
        self.assertEqual(self.bi.biState, val, "Unexpected biState value.")
        self.bi.biState = None
        self.assertEqual(self.bi.biState, None, "Unexpected biState value.")
        self.bi.biState = val
        self.assertEqual(self.bi.biState, val, "Unexpected biState value.")
