#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Data box owner information functionality.
#

import isds
import unittest

# Global owner info.
oi = isds.isds_db_owner_info()

class TestIsdsDbOwnerInfo(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsDbOwnerInfo, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.oi = isds.isds_db_owner_info()
        self.oi = None

    def test_dbID(self):
        self.oi = oi
        val = "abcdefg"
        self.assertEqual(self.oi.dbID, None, "Unexpected dbID value.")
        self.oi.dbID = val
        self.assertEqual(self.oi.dbID, val, "Unexpected dbID value.")
        self.oi.dbID = None
        self.assertEqual(self.oi.dbID, None, "Unexpected dbID value.")
        self.oi.dbID = val
        self.assertEqual(self.oi.dbID, val, "Unexpected dbID value.")

    def test_dbType(self):
        self.oi = oi
        val = isds.DBTYPE_FO
        self.assertEqual(self.oi.dbType, None, "Unexpected dbType value.")
        self.oi.dbType = val
        self.assertEqual(self.oi.dbType, val, "Unexpected dbType value.")
        self.oi.dbType = None
        self.assertEqual(self.oi.dbType, None, "Unexpected dbType value.")
        self.oi.dbType = val
        self.assertEqual(self.oi.dbType, val, "Unexpected dbType value.")

    def test_ic(self):
        self.oi = oi
        val = "1234"
        self.assertEqual(self.oi.ic, None, "Unexpected ic value.")
        self.oi.ic = val
        self.assertEqual(self.oi.ic, val, "Unexpected ic value.")
        self.oi.ic = None
        self.assertEqual(self.oi.ic, None, "Unexpected ic value.")
        self.oi.ic = val
        self.assertEqual(self.oi.ic, val, "Unexpected ic value.")

    def test_personName(self):
        self.oi = oi
        firstName = "Uwe"
        lastName = "Filter"
        val = isds.isds_person_name()
        val.pnFirstName = firstName
        val.pnLastName = lastName
        self.assertEqual(self.oi.personName, None, "Unexpected personName value.")
        self.oi.personName = val
        self.assertEqual(self.oi.personName.pnFirstName, firstName, "Unexpected personName value.")
        self.assertEqual(self.oi.personName.pnLastName, lastName, "Unexpected personName value.")
        self.oi.personName = None
        self.assertEqual(self.oi.personName, None, "Unexpected personName value.")
        self.oi.personName = val
        self.assertEqual(self.oi.personName.pnFirstName, firstName, "Unexpected personName value.")
        self.assertEqual(self.oi.personName.pnLastName, lastName, "Unexpected personName value.")

    def test_firmName(self):
        self.oi = oi
        val = "Firm name"
        self.assertEqual(self.oi.firmName, None, "Unexpected firmName value.")
        self.oi.firmName = val
        self.assertEqual(self.oi.firmName, val, "Unexpected firmName value.")
        self.oi.firmName = None
        self.assertEqual(self.oi.firmName, None, "Unexpected firmName value.")
        self.oi.firmName = val
        self.assertEqual(self.oi.firmName, val, "Unexpected firmName value.")

    def test_birthInfo(self):
        self.oi = oi
        val = isds.isds_birth_info()
        city = "City"
        val.biCity = city
        self.assertEqual(self.oi.birthInfo, None, "Unexpected birthInfo value.")
        self.oi.birthInfo = val
        self.assertEqual(self.oi.birthInfo.biCity, city, "Unexpected birthInfo value.")
        self.oi.birthInfo = None
        self.assertEqual(self.oi.birthInfo, None, "Unexpected birthInfo value.")
        self.oi.birthInfo = val
        self.assertEqual(self.oi.birthInfo.biCity, city, "Unexpected birthInfo value.")

    def test_address(self):
        self.oi = oi
        city = "City"
        val = isds.isds_address()
        val.adCity = city
        self.assertEqual(self.oi.address, None, "Unexpected address value.")
        self.oi.address = val
        self.assertEqual(self.oi.address.adCity, city, "Unexpected address value.")
        self.oi.address = None
        self.assertEqual(self.oi.address, None, "Unexpected address value.")
        self.oi.address = val
        self.assertEqual(self.oi.address.adCity, city, "Unexpected address value.")

    def test_nationality(self):
        self.oi = oi
        val = "Nationality"
        self.assertEqual(self.oi.nationality, None, "Unexpected nationality value.")
        self.oi.nationality = val
        self.assertEqual(self.oi.nationality, val, "Unexpected nationality value.")
        self.oi.nationality = None
        self.assertEqual(self.oi.nationality, None, "Unexpected nationality value.")
        self.oi.nationality = val
        self.assertEqual(self.oi.nationality, val, "Unexpected nationality value.")

    def test_email(self):
        self.oi = oi
        val = "Email"
        self.assertEqual(self.oi.email, None, "Unexpected email value.")
        self.oi.email = val
        self.assertEqual(self.oi.email, val, "Unexpected email value.")
        self.oi.email = None
        self.assertEqual(self.oi.email, None, "Unexpected email value.")
        self.oi.email = val
        self.assertEqual(self.oi.email, val, "Unexpected email value.")

    def test_telNumber(self):
        self.oi = oi
        val = "+420000000000"
        self.assertEqual(self.oi.telNumber, None, "Unexpected telNumber value.")
        self.oi.telNumber = val
        self.assertEqual(self.oi.telNumber, val, "Unexpected telNumber value.")
        self.oi.telNumber = None
        self.assertEqual(self.oi.telNumber, None, "Unexpected telNumber value.")
        self.oi.telNumber = val
        self.assertEqual(self.oi.telNumber, val, "Unexpected telNumber value.")

    def test_identifier(self):
        self.oi = oi
        val = "abcdef"
        self.assertEqual(self.oi.identifier, None, "Unexpected identifier value.")
        self.oi.identifier = val
        self.assertEqual(self.oi.identifier, val, "Unexpected identifier value.")
        self.oi.identifier = None
        self.assertEqual(self.oi.identifier, None, "Unexpected identifier value.")
        self.oi.identifier = val
        self.assertEqual(self.oi.identifier, val, "Unexpected identifier value.")

    #def test_aifoIsds(self):
    #    self.oi = oi
    #    self.assertEqual(self.oi.aifoIsds, None, "Unexpected aifoIsds value.")
    #    self.oi.aifoIsds = False
    #    self.assertEqual(self.oi.aifoIsds, False, "Unexpected aifoIsds value.")
    #    self.oi.aifoIsds = None
    #    self.assertEqual(self.oi.aifoIsds, None, "Unexpected aifoIsds value.")
    #    self.oi.aifoIsds = True
    #    self.assertEqual(self.oi.aifoIsds, True, "Unexpected aifoIsds value.")

    def test_registryCode(self):
        self.oi = oi
        val = "ab01"
        self.assertEqual(self.oi.registryCode, None, "Unexpected registryCode value.")
        self.oi.registryCode = val
        self.assertEqual(self.oi.registryCode, val, "Unexpected registryCode value.")
        self.oi.registryCode = None
        self.assertEqual(self.oi.registryCode, None, "Unexpected registryCode value.")
        self.oi.registryCode = val
        self.assertEqual(self.oi.registryCode, val, "Unexpected registryCode value.")

    def test_dbState(self):
        self.oi = oi
        val = 1
        self.assertEqual(self.oi.dbState, None, "Unexpected dbState value.")
        self.oi.dbState = val
        self.assertEqual(self.oi.dbState, val, "Unexpected dbState value.")
        self.oi.dbState = None
        self.assertEqual(self.oi.dbState, None, "Unexpected dbState value.")
        self.oi.dbState = val
        self.assertEqual(self.oi.dbState, val, "Unexpected dbState value.")

    def test_dbEffectiveOVM(self):
        self.oi = oi
        self.assertEqual(self.oi.dbEffectiveOVM, None, "Unexpected dbEffectiveOVM value.")
        self.oi.dbEffectiveOVM = False
        self.assertEqual(self.oi.dbEffectiveOVM, False, "Unexpected dbEffectiveOVM value.")
        self.oi.dbEffectiveOVM = None
        self.assertEqual(self.oi.dbEffectiveOVM, None, "Unexpected dbEffectiveOVM value.")
        self.oi.dbEffectiveOVM = True
        self.assertEqual(self.oi.dbEffectiveOVM, True, "Unexpected dbEffectiveOVM value.")

    def test_dbOpenAddressing(self):
        self.oi = oi
        self.assertEqual(self.oi.dbOpenAddressing, None, "Unexpected dbOpenAddressing value.")
        self.oi.dbOpenAddressing = False
        self.assertEqual(self.oi.dbOpenAddressing, False, "Unexpected dbOpenAddressing value.")
        self.oi.dbOpenAddressing = None
        self.assertEqual(self.oi.dbOpenAddressing, None, "Unexpected dbOpenAddressing value.")
        self.oi.dbOpenAddressing = True
        self.assertEqual(self.oi.dbOpenAddressing, True, "Unexpected dbOpenAddressing value.")
