#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Document functionality.
#

import isds
import unittest

# Global document.
doc = isds.isds_document()

class TestIsdsDocument(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsDocument, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.doc = isds.isds_document()
        self.doc = None

    def test_is_xml(self):
        self.doc = doc
        none = False
        val = True
        self.assertEqual(self.doc.is_xml, none, "Unexpected is_xml value.")
        self.doc.is_xml = val
        self.assertEqual(self.doc.is_xml, val, "Unexpected is_xml value.")
        self.doc.is_xml = none
        self.assertEqual(self.doc.is_xml, none, "Unexpected is_xml value.")
        self.doc.is_xml = val
        self.assertEqual(self.doc.is_xml, val, "Unexpected is_xml value.")

    def test_data(self):
        self.doc = doc
        none = b''
        val = b'1234'
        self.assertEqual(self.doc.data, none, "Unexpected data value.")
        self.doc.data = val
        self.assertEqual(self.doc.data, val, "Unexpected data value.")
        self.doc.data = None
        self.assertEqual(self.doc.data, none, "Unexpected data value.")
        self.doc.data = val
        self.assertEqual(self.doc.data, val, "Unexpected data value.")

    def test_dmMimeType(self):
        self.doc = doc
        val = "text/plain"
        self.assertEqual(self.doc.dmMimeType, None, "Unexpected dmMimeType value.")
        self.doc.dmMimeType = val
        self.assertEqual(self.doc.dmMimeType, val, "Unexpected dmMimeType value.")
        self.doc.dmMimeType = None
        self.assertEqual(self.doc.dmMimeType, None, "Unexpected dmMimeType value.")
        self.doc.dmMimeType = val
        self.assertEqual(self.doc.dmMimeType, val, "Unexpected dmMimeType value.")

    def test_dmFileMetaType(self):
        self.doc = doc
        none = isds.FILEMETATYPE_MAIN
        val = isds.FILEMETATYPE_ENCLOSURE
        self.assertEqual(self.doc.dmFileMetaType, none, "Unexpected dmFileMetaType value.")
        self.doc.dmFileMetaType = val
        self.assertEqual(self.doc.dmFileMetaType, val, "Unexpected dmFileMetaType value.")
        self.doc.dmFileMetaType = none
        self.assertEqual(self.doc.dmFileMetaType, none, "Unexpected dmFileMetaType value.")
        self.doc.dmFileMetaType = val
        self.assertEqual(self.doc.dmFileMetaType, val, "Unexpected dmFileMetaType value.")

    def test_dmFileGuid(self):
        self.doc = doc
        val = "file GUID"
        self.assertEqual(self.doc.dmFileGuid, None, "Unexpected dmFileGuid value.")
        self.doc.dmFileGuid = val
        self.assertEqual(self.doc.dmFileGuid, val, "Unexpected dmFileGuid value.")
        self.doc.dmFileGuid = None
        self.assertEqual(self.doc.dmFileGuid, None, "Unexpected dmFileGuid value.")
        self.doc.dmFileGuid = val
        self.assertEqual(self.doc.dmFileGuid, val, "Unexpected dmFileGuid value.")

    def test_dmUpFileGuid(self):
        self.doc = doc
        val = "up file GUID"
        self.assertEqual(self.doc.dmUpFileGuid, None, "Unexpected dmUpFileGuid value.")
        self.doc.dmUpFileGuid = val
        self.assertEqual(self.doc.dmUpFileGuid, val, "Unexpected dmUpFileGuid value.")
        self.doc.dmUpFileGuid = None
        self.assertEqual(self.doc.dmUpFileGuid, None, "Unexpected dmUpFileGuid value.")
        self.doc.dmUpFileGuid = val
        self.assertEqual(self.doc.dmUpFileGuid, val, "Unexpected dmUpFileGuid value.")

    def test_dmFileDescr(self):
        self.doc = doc
        val = "file descr"
        self.assertEqual(self.doc.dmFileDescr, None, "Unexpected dmFileDescr value.")
        self.doc.dmFileDescr = val
        self.assertEqual(self.doc.dmFileDescr, val, "Unexpected dmFileDescr value.")
        self.doc.dmFileDescr = None
        self.assertEqual(self.doc.dmFileDescr, None, "Unexpected dmFileDescr value.")
        self.doc.dmFileDescr = val
        self.assertEqual(self.doc.dmFileDescr, val, "Unexpected dmFileDescr value.")
