#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Envelope functionality.
#

import isds
import unittest

# Global envelope.
env = isds.isds_envelope()

class TestIsdsEnvelope(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsEnvelope, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.env = isds.isds_envelope()
        self.env = None

    def test_dmID(self):
        self.env = env
        val = "123456"
        self.assertEqual(self.env.dmID, None, "Unexpected dmID value.")
        self.env.dmID = val
        self.assertEqual(self.env.dmID, val, "Unexpected dmID value.")
        self.env.dmID = None
        self.assertEqual(self.env.dmID, None, "Unexpected dmID value.")
        self.env.dmID = val
        self.assertEqual(self.env.dmID, val, "Unexpected dmID value.")

    def test_dbIDSender(self):
        self.env = env
        val = "abcd12"
        self.assertEqual(self.env.dbIDSender, None, "Unexpected dbIDSender value.")
        self.env.dbIDSender = val
        self.assertEqual(self.env.dbIDSender, val, "Unexpected dbIDSender value.")
        self.env.dbIDSender = None
        self.assertEqual(self.env.dbIDSender, None, "Unexpected dbIDSender value.")
        self.env.dbIDSender = val
        self.assertEqual(self.env.dbIDSender, val, "Unexpected dbIDSender value.")

    def test_dmSender(self):
        self.env = env
        val = "Sender name"
        self.assertEqual(self.env.dmSender, None, "Unexpected dmSender value.")
        self.env.dmSender = val
        self.assertEqual(self.env.dmSender, val, "Unexpected dmSender value.")
        self.env.dmSender = None
        self.assertEqual(self.env.dmSender, None, "Unexpected dmSender value.")
        self.env.dmSender = val
        self.assertEqual(self.env.dmSender, val, "Unexpected dmSender value.")

    def test_dmSenderAddress(self):
        self.env = env
        val = "Sender address"
        self.assertEqual(self.env.dmSenderAddress, None, "Unexpected dmSenderAddress value.")
        self.env.dmSenderAddress = val
        self.assertEqual(self.env.dmSenderAddress, val, "Unexpected dmSenderAddress value.")
        self.env.dmSenderAddress = None
        self.assertEqual(self.env.dmSenderAddress, None, "Unexpected dmSenderAddress value.")
        self.env.dmSenderAddress = val
        self.assertEqual(self.env.dmSenderAddress, val, "Unexpected dmSenderAddress value.")

    def test_dmSenderType(self):
        self.env = env
        val = 40
        self.assertEqual(self.env.dmSenderType, None, "Unexpected dmSenderType value.")
        self.env.dmSenderType = val
        self.assertEqual(self.env.dmSenderType, val, "Unexpected dmSenderType value.")
        self.env.dmSenderType = None
        self.assertEqual(self.env.dmSenderType, None, "Unexpected dmSenderType value.")
        self.env.dmSenderType = val
        self.assertEqual(self.env.dmSenderType, val, "Unexpected dmSenderType value.")

    def test_dmRecipient(self):
        self.env = env
        val = "Recipient name"
        self.assertEqual(self.env.dmRecipient, None, "Unexpected dmRecipient value.")
        self.env.dmRecipient = val
        self.assertEqual(self.env.dmRecipient, val, "Unexpected dmRecipient value.")
        self.env.dmRecipient = None
        self.assertEqual(self.env.dmRecipient, None, "Unexpected dmRecipient value.")
        self.env.dmRecipient = val
        self.assertEqual(self.env.dmRecipient, val, "Unexpected dmRecipient value.")

    def test_dmRecipientAddress(self):
        self.env = env
        val = "Recipient address"
        self.assertEqual(self.env.dmRecipientAddress, None, "Unexpected dmRecipientAddress value.")
        self.env.dmRecipientAddress = val
        self.assertEqual(self.env.dmRecipientAddress, val, "Unexpected dmRecipientAddress value.")
        self.env.dmRecipientAddress = None
        self.assertEqual(self.env.dmRecipientAddress, None, "Unexpected dmRecipientAddress value.")
        self.env.dmRecipientAddress = val
        self.assertEqual(self.env.dmRecipientAddress, val, "Unexpected dmRecipientAddress value.")

    def test_dmAmbiguousRecipient(self):
        self.env = env
        self.assertEqual(self.env.dmAmbiguousRecipient, None, "Unexpected dmAmbiguousRecipient value.")
        self.env.dmAmbiguousRecipient = False
        self.assertEqual(self.env.dmAmbiguousRecipient, False, "Unexpected dmAmbiguousRecipient value.")
        self.env.dmAmbiguousRecipient = None
        self.assertEqual(self.env.dmAmbiguousRecipient, None, "Unexpected dmAmbiguousRecipient value.")
        self.env.dmAmbiguousRecipient = True
        self.assertEqual(self.env.dmAmbiguousRecipient, True, "Unexpected dmAmbiguousRecipient value.")

    def test_dmOrdinal(self):
        self.env = env
        val = 4
        self.assertEqual(self.env.dmOrdinal, None, "Unexpected dmOrdinal value.")
        self.env.dmOrdinal = val
        self.assertEqual(self.env.dmOrdinal, val, "Unexpected dmOrdinal value.")
        self.env.dmOrdinal = None
        self.assertEqual(self.env.dmOrdinal, None, "Unexpected dmOrdinal value.")
        self.env.dmOrdinal = val
        self.assertEqual(self.env.dmOrdinal, val, "Unexpected dmOrdinal value.")

    def test_dmMessageStatus(self):
        self.env = env
        val = isds.MESSAGESTATE_RECEIVED
        self.assertEqual(self.env.dmMessageStatus, None, "Unexpected dmMessageStatus value.")
        self.env.dmMessageStatus = val
        self.assertEqual(self.env.dmMessageStatus, val, "Unexpected dmMessageStatus value.")
        self.env.dmMessageStatus = None
        self.assertEqual(self.env.dmMessageStatus, None, "Unexpected dmMessageStatus value.")
        self.env.dmMessageStatus = val
        self.assertEqual(self.env.dmMessageStatus, val, "Unexpected dmMessageStatus value.")

    def test_dmAttachmentSize(self):
        self.env = env
        val = 4
        self.assertEqual(self.env.dmAttachmentSize, None, "Unexpected dmAttachmentSize value.")
        self.env.dmAttachmentSize = val
        self.assertEqual(self.env.dmAttachmentSize, val, "Unexpected dmAttachmentSize value.")
        self.env.dmAttachmentSize = None
        self.assertEqual(self.env.dmAttachmentSize, None, "Unexpected dmAttachmentSize value.")
        self.env.dmAttachmentSize = val
        self.assertEqual(self.env.dmAttachmentSize, val, "Unexpected dmAttachmentSize value.")

    def test_dmDeliveryTime(self):
        self.env = env
        val = isds.isds_time(10, 20)
        self.assertEqual(self.env.dmDeliveryTime, None, "Unexpected dmDeliveryTime value.")
        self.env.dmDeliveryTime = val
        self.assertEqual(self.env.dmDeliveryTime, val, "Unexpected dmDeliveryTime value.")
        self.env.dmDeliveryTime = None
        self.assertEqual(self.env.dmDeliveryTime, None, "Unexpected dmDeliveryTime value.")
        self.env.dmDeliveryTime = val
        self.assertEqual(self.env.dmDeliveryTime, val, "Unexpected dmDeliveryTime value.")

    def test_dmAcceptanceTime(self):
        self.env = env
        val = isds.isds_time(10, 40)
        self.assertEqual(self.env.dmAcceptanceTime, None, "Unexpected dmAcceptanceTime value.")
        self.env.dmAcceptanceTime = val
        self.assertEqual(self.env.dmAcceptanceTime, val, "Unexpected dmAcceptanceTime value.")
        self.env.dmAcceptanceTime = None
        self.assertEqual(self.env.dmAcceptanceTime, None, "Unexpected dmAcceptanceTime value.")
        self.env.dmAcceptanceTime = val
        self.assertEqual(self.env.dmAcceptanceTime, val, "Unexpected dmAcceptanceTime value.")

    def test_hash(self):
        self.env = env
        val = isds.isds_hash()
        val.algorithm = isds.HASH_ALGORITHM_MD5
        val.value = b'1234'
        self.assertEqual(self.env.hash, None, "Unexpected hash value.")
        self.env.hash = val
        self.assertEqual(self.env.hash, val, "Unexpected hash value.")
        self.env.hash = None
        self.assertEqual(self.env.hash, None, "Unexpected hash value.")
        self.env.hash = val
        self.assertEqual(self.env.hash, val, "Unexpected hash value.")

    def test_timestamp(self):
        self.env = env
        none = b''
        val = b'1234'
        self.assertEqual(self.env.timestamp, none, "Unexpected timestamp value.")
        self.env.timestamp = val
        self.assertEqual(self.env.timestamp, val, "Unexpected timestamp value.")
        self.env.timestamp = None
        self.assertEqual(self.env.timestamp, none, "Unexpected timestamp value.")
        self.env.timestamp = val
        self.assertEqual(self.env.timestamp, val, "Unexpected timestamp value.")

    def test_events(self):
        self.env = env
        val = []
        event = isds.isds_event()
        val.append(event)
        self.assertEqual(self.env.events, [], "Unexpected events value.")
        self.env.events = val
        self.assertEqual(len(self.env.events), 1, "Unexpected events value.")
        self.env.events = []
        self.assertEqual(self.env.events, [], "Unexpected events value.")
        self.env.events = val
        self.assertEqual(len(self.env.events), 1, "Unexpected events value.")

    def test_dmSenderOrgUnit(self):
        self.env = env
        val = "Sender organisation unit"
        self.assertEqual(self.env.dmSenderOrgUnit, None, "Unexpected dmSenderOrgUnit value.")
        self.env.dmSenderOrgUnit = val
        self.assertEqual(self.env.dmSenderOrgUnit, val, "Unexpected dmSenderOrgUnit value.")
        self.env.dmSenderOrgUnit = None
        self.assertEqual(self.env.dmSenderOrgUnit, None, "Unexpected dmSenderOrgUnit value.")
        self.env.dmSenderOrgUnit = val
        self.assertEqual(self.env.dmSenderOrgUnit, val, "Unexpected dmSenderOrgUnit value.")

    def test_dmSenderOrgUnitNum(self):
        self.env = env
        val = 6
        self.assertEqual(self.env.dmSenderOrgUnitNum, None, "Unexpected dmSenderOrgUnitNum value.")
        self.env.dmSenderOrgUnitNum = val
        self.assertEqual(self.env.dmSenderOrgUnitNum, val, "Unexpected dmSenderOrgUnitNum value.")
        self.env.dmSenderOrgUnitNum = None
        self.assertEqual(self.env.dmSenderOrgUnitNum, None, "Unexpected dmSenderOrgUnitNum value.")
        self.env.dmSenderOrgUnitNum = val
        self.assertEqual(self.env.dmSenderOrgUnitNum, val, "Unexpected dmSenderOrgUnitNum value.")

    def test_dbIDRecipient(self):
        self.env = env
        val = "abcd14"
        self.assertEqual(self.env.dbIDRecipient, None, "Unexpected dbIDRecipient value.")
        self.env.dbIDRecipient = val
        self.assertEqual(self.env.dbIDRecipient, val, "Unexpected dbIDRecipient value.")
        self.env.dbIDRecipient = None
        self.assertEqual(self.env.dbIDRecipient, None, "Unexpected dbIDRecipient value.")
        self.env.dbIDRecipient = val
        self.assertEqual(self.env.dbIDRecipient, val, "Unexpected dbIDRecipient value.")

    def test_dmRecipientOrgUnit(self):
        self.env = env
        val = "Recipient organisation unit"
        self.assertEqual(self.env.dmRecipientOrgUnit, None, "Unexpected dmRecipientOrgUnit value.")
        self.env.dmRecipientOrgUnit = val
        self.assertEqual(self.env.dmRecipientOrgUnit, val, "Unexpected dmRecipientOrgUnit value.")
        self.env.dmRecipientOrgUnit = None
        self.assertEqual(self.env.dmRecipientOrgUnit, None, "Unexpected dmRecipientOrgUnit value.")
        self.env.dmRecipientOrgUnit = val
        self.assertEqual(self.env.dmRecipientOrgUnit, val, "Unexpected dmRecipientOrgUnit value.")

    def test_dmRecipientOrgUnitNum(self):
        self.env = env
        val = 7
        self.assertEqual(self.env.dmRecipientOrgUnitNum, None, "Unexpected dmRecipientOrgUnitNum value.")
        self.env.dmRecipientOrgUnitNum = val
        self.assertEqual(self.env.dmRecipientOrgUnitNum, val, "Unexpected dmRecipientOrgUnitNum value.")
        self.env.dmRecipientOrgUnitNum = None
        self.assertEqual(self.env.dmRecipientOrgUnitNum, None, "Unexpected dmRecipientOrgUnitNum value.")
        self.env.dmRecipientOrgUnitNum = val
        self.assertEqual(self.env.dmRecipientOrgUnitNum, val, "Unexpected dmRecipientOrgUnitNum value.")

    def test_dmToHands(self):
        self.env = env
        val = "To hands"
        self.assertEqual(self.env.dmToHands, None, "Unexpected dmToHands value.")
        self.env.dmToHands = val
        self.assertEqual(self.env.dmToHands, val, "Unexpected dmToHands value.")
        self.env.dmToHands = None
        self.assertEqual(self.env.dmToHands, None, "Unexpected dmToHands value.")
        self.env.dmToHands = val
        self.assertEqual(self.env.dmToHands, val, "Unexpected dmToHands value.")

    def test_dmAnnotation(self):
        self.env = env
        val = "Annotation"
        self.assertEqual(self.env.dmAnnotation, None, "Unexpected dmAnnotation value.")
        self.env.dmAnnotation = val
        self.assertEqual(self.env.dmAnnotation, val, "Unexpected dmAnnotation value.")
        self.env.dmAnnotation = None
        self.assertEqual(self.env.dmAnnotation, None, "Unexpected dmAnnotation value.")
        self.env.dmAnnotation = val
        self.assertEqual(self.env.dmAnnotation, val, "Unexpected dmAnnotation value.")

    def test_dmRecipientRefNumber(self):
        self.env = env
        val = "Recipient reference number"
        self.assertEqual(self.env.dmRecipientRefNumber, None, "Unexpected dmRecipientRefNumber value.")
        self.env.dmRecipientRefNumber = val
        self.assertEqual(self.env.dmRecipientRefNumber, val, "Unexpected dmRecipientRefNumber value.")
        self.env.dmRecipientRefNumber = None
        self.assertEqual(self.env.dmRecipientRefNumber, None, "Unexpected dmRecipientRefNumber value.")
        self.env.dmRecipientRefNumber = val
        self.assertEqual(self.env.dmRecipientRefNumber, val, "Unexpected dmRecipientRefNumber value.")

    def test_dmSenderRefNumber(self):
        self.env = env
        val = "Sender reference number"
        self.assertEqual(self.env.dmSenderRefNumber, None, "Unexpected dmSenderRefNumber value.")
        self.env.dmSenderRefNumber = val
        self.assertEqual(self.env.dmSenderRefNumber, val, "Unexpected dmSenderRefNumber value.")
        self.env.dmSenderRefNumber = None
        self.assertEqual(self.env.dmSenderRefNumber, None, "Unexpected dmSenderRefNumber value.")
        self.env.dmSenderRefNumber = val
        self.assertEqual(self.env.dmSenderRefNumber, val, "Unexpected dmSenderRefNumber value.")

    def test_dmRecipientIdent(self):
        self.env = env
        val = "Recipient identification"
        self.assertEqual(self.env.dmRecipientIdent, None, "Unexpected dmRecipientIdent value.")
        self.env.dmRecipientIdent = val
        self.assertEqual(self.env.dmRecipientIdent, val, "Unexpected dmRecipientIdent value.")
        self.env.dmRecipientIdent = None
        self.assertEqual(self.env.dmRecipientIdent, None, "Unexpected dmRecipientIdent value.")
        self.env.dmRecipientIdent = val
        self.assertEqual(self.env.dmRecipientIdent, val, "Unexpected dmRecipientIdent value.")

    def test_dmSenderIdent(self):
        self.env = env
        val = "Sender identification"
        self.assertEqual(self.env.dmSenderIdent, None, "Unexpected dmSenderIdent value.")
        self.env.dmSenderIdent = val
        self.assertEqual(self.env.dmSenderIdent, val, "Unexpected dmSenderIdent value.")
        self.env.dmSenderIdent = None
        self.assertEqual(self.env.dmSenderIdent, None, "Unexpected dmSenderIdent value.")
        self.env.dmSenderIdent = val
        self.assertEqual(self.env.dmSenderIdent, val, "Unexpected dmSenderIdent value.")

    def test_dmLegalTitleLaw(self):
        self.env = env
        val = 120
        self.assertEqual(self.env.dmLegalTitleLaw, None, "Unexpected dmLegalTitleLaw value.")
        self.env.dmLegalTitleLaw = val
        self.assertEqual(self.env.dmLegalTitleLaw, val, "Unexpected dmLegalTitleLaw value.")
        self.env.dmLegalTitleLaw = None
        self.assertEqual(self.env.dmLegalTitleLaw, None, "Unexpected dmLegalTitleLaw value.")
        self.env.dmLegalTitleLaw = val
        self.assertEqual(self.env.dmLegalTitleLaw, val, "Unexpected dmLegalTitleLaw value.")

    def test_dmLegalTitleYear(self):
        self.env = env
        val = 2008
        self.assertEqual(self.env.dmLegalTitleYear, None, "Unexpected dmLegalTitleYear value.")
        self.env.dmLegalTitleYear = val
        self.assertEqual(self.env.dmLegalTitleYear, val, "Unexpected dmLegalTitleYear value.")
        self.env.dmLegalTitleYear = None
        self.assertEqual(self.env.dmLegalTitleYear, None, "Unexpected dmLegalTitleYear value.")
        self.env.dmLegalTitleYear = val
        self.assertEqual(self.env.dmLegalTitleYear, val, "Unexpected dmLegalTitleYear value.")

    def test_dmLegalTitleSect(self):
        self.env = env
        val = "Legal section"
        self.assertEqual(self.env.dmLegalTitleSect, None, "Unexpected dmLegalTitleSect value.")
        self.env.dmLegalTitleSect = val
        self.assertEqual(self.env.dmLegalTitleSect, val, "Unexpected dmLegalTitleSect value.")
        self.env.dmLegalTitleSect = None
        self.assertEqual(self.env.dmLegalTitleSect, None, "Unexpected dmLegalTitleSect value.")
        self.env.dmLegalTitleSect = val
        self.assertEqual(self.env.dmLegalTitleSect, val, "Unexpected dmLegalTitleSect value.")

    def test_dmLegalTitlePar(self):
        self.env = env
        val = "Legal paragraph"
        self.assertEqual(self.env.dmLegalTitlePar, None, "Unexpected dmLegalTitlePar value.")
        self.env.dmLegalTitlePar = val
        self.assertEqual(self.env.dmLegalTitlePar, val, "Unexpected dmLegalTitlePar value.")
        self.env.dmLegalTitlePar = None
        self.assertEqual(self.env.dmLegalTitlePar, None, "Unexpected dmLegalTitlePar value.")
        self.env.dmLegalTitlePar = val
        self.assertEqual(self.env.dmLegalTitlePar, val, "Unexpected dmLegalTitlePar value.")

    def test_dmLegalTitlePoint(self):
        self.env = env
        val = "Legal point"
        self.assertEqual(self.env.dmLegalTitlePoint, None, "Unexpected dmLegalTitlePoint value.")
        self.env.dmLegalTitlePoint = val
        self.assertEqual(self.env.dmLegalTitlePoint, val, "Unexpected dmLegalTitlePoint value.")
        self.env.dmLegalTitlePoint = None
        self.assertEqual(self.env.dmLegalTitlePoint, None, "Unexpected dmLegalTitlePoint value.")
        self.env.dmLegalTitlePoint = val
        self.assertEqual(self.env.dmLegalTitlePoint, val, "Unexpected dmLegalTitlePoint value.")

    def test_dmPersonalDelivery(self):
        self.env = env
        self.assertEqual(self.env.dmPersonalDelivery, None, "Unexpected dmPersonalDelivery value.")
        self.env.dmPersonalDelivery = False
        self.assertEqual(self.env.dmPersonalDelivery, False, "Unexpected dmPersonalDelivery value.")
        self.env.dmPersonalDelivery = None
        self.assertEqual(self.env.dmPersonalDelivery, None, "Unexpected dmPersonalDelivery value.")
        self.env.dmPersonalDelivery = True
        self.assertEqual(self.env.dmPersonalDelivery, True, "Unexpected dmPersonalDelivery value.")

    def test_dmAllowSubstDelivery(self):
        self.env = env
        self.assertEqual(self.env.dmAllowSubstDelivery, None, "Unexpected dmAllowSubstDelivery value.")
        self.env.dmAllowSubstDelivery = False
        self.assertEqual(self.env.dmAllowSubstDelivery, False, "Unexpected dmAllowSubstDelivery value.")
        self.env.dmAllowSubstDelivery = None
        self.assertEqual(self.env.dmAllowSubstDelivery, None, "Unexpected dmAllowSubstDelivery value.")
        self.env.dmAllowSubstDelivery = True
        self.assertEqual(self.env.dmAllowSubstDelivery, True, "Unexpected dmAllowSubstDelivery value.")

    def test_dmType(self):
        self.env = env
        val = "V"
        self.assertEqual(self.env.dmType, None, "Unexpected dmType value.")
        self.env.dmType = val
        self.assertEqual(self.env.dmType, val, "Unexpected dmType value.")
        self.env.dmType = None
        self.assertEqual(self.env.dmType, None, "Unexpected dmType value.")
        self.env.dmType = val
        self.assertEqual(self.env.dmType, val, "Unexpected dmType value.")

    def test_dmOVM(self):
        self.env = env
        self.assertEqual(self.env.dmOVM, None, "Unexpected dmOVM value.")
        self.env.dmOVM = False
        self.assertEqual(self.env.dmOVM, False, "Unexpected dmOVM value.")
        self.env.dmOVM = None
        self.assertEqual(self.env.dmOVM, None, "Unexpected dmOVM value.")
        self.env.dmOVM = True
        self.assertEqual(self.env.dmOVM, True, "Unexpected dmOVM value.")

    def test_dmPublishOwnID(self):
        self.env = env
        self.assertEqual(self.env.dmPublishOwnID, None, "Unexpected dmPublishOwnID value.")
        self.env.dmPublishOwnID = False
        self.assertEqual(self.env.dmPublishOwnID, False, "Unexpected dmPublishOwnID value.")
        self.env.dmPublishOwnID = None
        self.assertEqual(self.env.dmPublishOwnID, None, "Unexpected dmPublishOwnID value.")
        self.env.dmPublishOwnID = True
        self.assertEqual(self.env.dmPublishOwnID, True, "Unexpected dmPublishOwnID value.")
