#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Event functionality.
#

import isds
import unittest

# Global event.
ev = isds.isds_event()

class TestIsdsEvent(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsEvent, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.ev = isds.isds_event()
        self.ev = None

    def test_time(self):
        self.ev = ev
        val = isds.isds_time(10, 20)
        self.assertEqual(self.ev.time, None, "Unexpected time value.")
        self.ev.time = val
        self.assertEqual(self.ev.time, val, "Unexpected time value.")
        self.ev.time = None
        self.assertEqual(self.ev.time, None, "Unexpected time value.")
        self.ev.time = val
        self.assertEqual(self.ev.time, val, "Unexpected time value.")

    def test_type(self):
        self.ev = ev
        val = isds.EVENT_DELIVERED
        self.assertEqual(self.ev.type, None, "Unexpected type value.")
        self.ev.type = val
        self.assertEqual(self.ev.type, val, "Unexpected type value.")
        self.ev.type = None
        self.assertEqual(self.ev.type, None, "Unexpected type value.")
        self.ev.type = val
        self.assertEqual(self.ev.type, val, "Unexpected type value.")

    def test_description(self):
        self.ev = ev
        val = "Event"
        self.assertEqual(self.ev.description, None, "Unexpected description value.")
        self.ev.description = val
        self.assertEqual(self.ev.description, val, "Unexpected description value.")
        self.ev.description = None
        self.assertEqual(self.ev.description, None, "Unexpected description value.")
        self.ev.description = val
        self.assertEqual(self.ev.description, val, "Unexpected description value.")
