#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Full-text result metadata functionality.
#

import isds
import unittest

# Global full-text result metadata.
frm = isds.isds_fulltext_result_meta()

class TestIsdsFulltextResultMeta(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsFulltextResultMeta, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.frm = isds.isds_fulltext_result_meta()
        self.frm = None

    def test_total_matching_boxes(self):
        self.frm = frm
        val = 4
        self.assertEqual(self.frm.total_matching_boxes, None, "Unexpected total_matching_boxes value.")
        self.frm.total_matching_boxes = val
        self.assertEqual(self.frm.total_matching_boxes, val, "Unexpected total_matching_boxes value.")
        self.frm.total_matching_boxes = None
        self.assertEqual(self.frm.total_matching_boxes, None, "Unexpected total_matching_boxes value.")
        self.frm.total_matching_boxes = val
        self.assertEqual(self.frm.total_matching_boxes, val, "Unexpected total_matching_boxes value.")

    def test_current_page_beginning(self):
        self.frm = frm
        val = 4
        self.assertEqual(self.frm.current_page_beginning, None, "Unexpected current_page_beginning value.")
        self.frm.current_page_beginning = val
        self.assertEqual(self.frm.current_page_beginning, val, "Unexpected current_page_beginning value.")
        self.frm.current_page_beginning = None
        self.assertEqual(self.frm.current_page_beginning, None, "Unexpected current_page_beginning value.")
        self.frm.current_page_beginning = val
        self.assertEqual(self.frm.current_page_beginning, val, "Unexpected current_page_beginning value.")

    def test_current_page_size(self):
        self.frm = frm
        val = 4
        self.assertEqual(self.frm.current_page_size, None, "Unexpected current_page_size value.")
        self.frm.current_page_size = val
        self.assertEqual(self.frm.current_page_size, val, "Unexpected current_page_size value.")
        self.frm.current_page_size = None
        self.assertEqual(self.frm.current_page_size, None, "Unexpected current_page_size value.")
        self.frm.current_page_size = val
        self.assertEqual(self.frm.current_page_size, val, "Unexpected current_page_size value.")

    def test_last_page(self):
        self.frm = frm
        self.assertEqual(self.frm.last_page, None, "Unexpected last_page value.")
        self.frm.last_page = False
        self.assertEqual(self.frm.last_page, False, "Unexpected last_page value.")
        self.frm.last_page = None
        self.assertEqual(self.frm.last_page, None, "Unexpected last_page value.")
        self.frm.last_page = True
        self.assertEqual(self.frm.last_page, True, "Unexpected last_page value.")

    def test_boxes(self):
        self.frm = frm
        val = []
        fr = isds.isds_fulltext_result()
        val.append(fr)
        self.assertEqual(self.frm.boxes, [], "Unexpected boxes value.")
        self.frm.boxes = val
        self.assertEqual(len(self.frm.boxes), 1, "Unexpected boxes value.")
        self.frm.boxes = []
        self.assertEqual(self.frm.boxes, [], "Unexpected boxes value.")
        self.frm.boxes = val
        self.assertEqual(len(self.frm.boxes), 1, "Unexpected boxes value.")
